package com.loafle.overflow.model.meta;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "META_CRAWLER_INPUT_ITEM", schema = "public")
public class MetaCrawlerInputItem {
  private Integer id;
  private String name;
  private MetaInputType metaInputType;
  private MetaCrawler metaCrawler;
  private Boolean required;
  private String defaultValue;
  private String pattern;
  private String keyName;
  private String keyValue;
  private Date createDate;

  @Id
  public Integer getId() {
    return id;
  }

  public void setId(Integer id) {
    this.id = id;
  }

  @ManyToOne
  @JoinColumn(name = "META_INPUT_TYPE_ID", nullable = false)
  public MetaInputType getMetaInputType() {
    return metaInputType;
  }

  public void setMetaInputType(MetaInputType metaInputType) {
    this.metaInputType = metaInputType;
  }

  @ManyToOne
  @JoinColumn(name = "META_CRAWLER_ID", nullable = false)
  public MetaCrawler getMetaCrawler() {
    return metaCrawler;
  }

  public void setMetaCrawler(MetaCrawler metaCrawler) {
    this.metaCrawler = metaCrawler;
  }

  @Column(name = "NAME", nullable = true, length = 50)
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  @Column(name = "REQUIRED", nullable = false)
  public Boolean isRequired() {
    return required;
  }

  public void setRequired(Boolean required) {
    this.required = required;
  }

  @Column(name = "DEFAULT_VALUE", nullable = true, length = 50)
  public String getDefaultValue() {
    return defaultValue;
  }

  public void setDefaultValue(String defaultValue) {
    this.defaultValue = defaultValue;
  }

  @Column(name = "PATTERN", nullable = true, length = 50)
  public String getPattern() {
    return pattern;
  }

  public void setPattern(String pattern) {
    this.pattern = pattern;
  }

  @Column(name = "KEY_NAME", nullable = true, length = 50)
  public String getKeyName() {
    return keyName;
  }

  public void setKeyName(String keyName) {
    this.keyName = keyName;
  }

  @Column(name = "KEY_VALUE", nullable = true, length = 50)
  public String getKeyValue() {
    return keyValue;
  }

  public void setKeyValue(String keyValue) {
    this.keyValue = keyValue;
  }

  // @Override
  // public Boolean equals(Object o) {
  // if (this == o) return true;
  // if (o == null || getClass() != o.getClass()) return false;
  //
  // MetaCrawlerInputItem that = (MetaCrawlerInputItem) o;
  //
  // if (id != that.id) return false;
  // if (typeId != that.typeId) return false;
  // if (crawlerId != that.crawlerId) return false;
  // if (required != that.required) return false;
  // if (desc != null ? !desc.equals(that.desc) : that.desc != null) return false;
  // if (name != null ? !name.equals(that.name) : that.name != null) return false;
  // if (createDate != null ? !createDate.equals(that.createDate) :
  // that.createDate != null) return false;
  // if (defaultValue != null ? !defaultValue.equals(that.defaultValue) :
  // that.defaultValue != null) return false;
  // if (pattern != null ? !pattern.equals(that.pattern) : that.pattern != null)
  // return false;
  // if (keyName != null ? !keyName.equals(that.keyName) : that.keyName != null)
  // return false;
  // if (keyValue != null ? !keyValue.equals(that.keyValue) : that.keyValue !=
  // null) return false;
  //
  // return true;
  // }
  //
  // @Override
  // public int hashCode() {
  // int result = id;
  // result = 31 * result + (int) typeId;
  // result = 31 * result + (int) crawlerId;
  // result = 31 * result + (desc != null ? desc.hashCode() : 0);
  // result = 31 * result + (name != null ? name.hashCode() : 0);
  // result = 31 * result + (createDate != null ? createDate.hashCode() : 0);
  // result = 31 * result + (required ? 1 : 0);
  // result = 31 * result + (defaultValue != null ? defaultValue.hashCode() : 0);
  // result = 31 * result + (pattern != null ? pattern.hashCode() : 0);
  // result = 31 * result + (keyName != null ? keyName.hashCode() : 0);
  // result = 31 * result + (keyValue != null ? keyValue.hashCode() : 0);
  // return result;
  // }
}
