package com.loafle.overflow.model.meta;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by insanity on 17. 9. 20.
 */
@Entity
@Table(name = "META_SENSOR_DISPLAY_ITEM", schema = "public")
public class MetaSensorDisplayItem {

  private Long id;
  private String key;
  private String name;
  private Boolean isDefault;
  private MetaCrawler metaCrawler;
  private MetaSensorItemUnit metaSensorItemUnit;
  private MetaSensorItemType metaSensorItemType;
  private Date createDate;

  public MetaSensorDisplayItem() {

  }

  public MetaSensorDisplayItem(Long id) {
    this.id = id;
  }

  @Id
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  @Column(name = "KEY", nullable = false)
  public String getKey() {
    return key;
  }

  public void setKey(String key) {
    this.key = key;
  }

  @Column(name = "NAME", nullable = false)
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  @ManyToOne
  @JoinColumn(name = "META_CRAWLER_ID", nullable = false)
  public MetaCrawler getMetaCrawler() {
    return metaCrawler;
  }

  public void setMetaCrawler(MetaCrawler metaCrawler) {
    this.metaCrawler = metaCrawler;
  }

  @ManyToOne
  @JoinColumn(name = "META_SENSOR_ITEM_UNIT_ID", nullable = true)
  public MetaSensorItemUnit getMetaSensorItemUnit() {
    return metaSensorItemUnit;
  }

  public void setMetaSensorItemUnit(MetaSensorItemUnit metaSensorItemUnit) {
    this.metaSensorItemUnit = metaSensorItemUnit;
  }

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  @Basic
  @Column(name = "IS_DEFAULT", nullable = false, columnDefinition = "Boolean default false")
  public Boolean getDefault() {
    return isDefault;
  }

  public void setDefault(Boolean aDefault) {
    isDefault = aDefault;
  }

  @ManyToOne
  @JoinColumn(name = "META_SENSOR_ITEM_TYPE_ID", nullable = false)
  public MetaSensorItemType getMetaSensorItemType() {
    return metaSensorItemType;
  }

  public void setMetaSensorItemType(MetaSensorItemType metaSensorItemType) {
    this.metaSensorItemType = metaSensorItemType;
  }

}
