package com.loafle.overflow.model.meta;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by snoop on 17. 8. 29.
 */
@Entity
@Table(name = "META_SENSOR_ITEM_KEY", schema = "public")
public class MetaSensorItemKey {
  private Long id;
  private String key;
  private String name;
  private String froms;
  private String option;
  private MetaSensorItem metaSensorItem;
  private MetaCrawler metaCrawler;
  private MetaSensorItemUnit metaSensorItemUnit;
  private Date createDate;

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  @Column(name = "NAME", nullable = true, length = 100)
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  @ManyToOne
  @JoinColumn(name = "META_SENSOR_ITEM_ID", nullable = false)
  public MetaSensorItem getMetaSensorItem() {
    return metaSensorItem;
  }

  public void setMetaSensorItem(MetaSensorItem metaSensorItem) {
    this.metaSensorItem = metaSensorItem;
  }

  @Column(name = "KEY", nullable = false, length = 100)
  public String getKey() {
    return key;
  }

  public void setKey(String key) {
    this.key = key;
  }

  @Column(name = "FROMS", nullable = false, length = 100)
  public String getFroms() {
    return froms;
  }

  public void setFroms(String froms) {
    this.froms = froms;
  }

  @Column(name = "OPTION_JSON", nullable = true)
  public String getOption() {
    return option;
  }

  public void setOption(String option) {
    this.option = option;
  }

  @ManyToOne
  @JoinColumn(name = "META_CRAWLER_ID", nullable = false)
  public MetaCrawler getMetaCrawler() {
    return metaCrawler;
  }

  public void setMetaCrawler(MetaCrawler metaCrawler) {
    this.metaCrawler = metaCrawler;
  }

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  @ManyToOne
  @JoinColumn(name = "META_SENSOR_ITEM_UNIT_ID", nullable = true)
  public MetaSensorItemUnit getMetaSensorItemUnit() {
    return metaSensorItemUnit;
  }

  public void setMetaSensorItemUnit(MetaSensorItemUnit metaSensorItemUnit) {
    this.metaSensorItemUnit = metaSensorItemUnit;
  }
}
